package comm_plan

import (
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"fmt"
)

// 按总佣金的比例进行划分计算
func CalcOther(opt *PlanOpt, totalAmt, integralTotalAmt float64, userList *LvUser, pvd string, sysFee float64, integralSysFee float64) error {
	grade := opt.UserRate
	if len(grade) == 0 {
		return zhios_order_relate_logx.Warn("level grade is not set")
	}

	//查出用户自购佣金
	commission, commissionRatio, amountList, ratioList := CalReturnAmountAndRatio(userList.Lv, userList.OwnbuyReturnType, 0, "own", totalAmt, integralTotalAmt, opt)
	userList.Profit = commission     // 另外出来的佣金 兼容旧的
	userList.ProfitList = amountList // 各币种分佣
	userList.SubsidyFee = 0
	ratioListMap := convertList2Map(ratioList)

	for k, v := range userList.ProfitList {
		userList.ProfitList[k].Val = ratioListMap[v.Cid] * v.Val
	}
	// 各种币换算出总的额度
	totalAmtList := make([]*VirtualCoinCommission, 0)
	for coinId, rate := range opt.VirtualCoinMoneyRatioList {
		var amount float64
		if coinId == 0 {
			amount = totalAmt
		} else {
			amount = integralTotalAmt * zhios_order_relate_utils.AnyToFloat64(rate)
		}
		totalAmtList = append(totalAmtList, &VirtualCoinCommission{
			Cid: zhios_order_relate_utils.AnyToString(coinId),
			Val: amount,
		})
	}

	var (
		node                         = userList
		maxLv                        = node.Lv                           // 当前等级
		maxLevelWeight               = node.LevelWeight                  // 当前权重
		peerNum                      = 0                                 // 存在同级数
		peerRate             float64 = 0                                 // 同级累计比例
		peerRateList                 = make([]*VirtualCoinCommission, 0) // 各虚拟币同级累计
		restAmtList                  = make([]*VirtualCoinCommission, 0) // 各虚拟币剩余额度
		accumulateRatioList          = make([]*VirtualCoinCommission, 0) // 各虚拟币累计比例
		restAmt                      = totalAmt - userList.Profit        // 剩余比例
		totalCommissionRatio         = commissionRatio                   // 累计佣金比例
	)
	// 计算剩余额度
	restAmtList, _ = CalVirtualCommissionMinus(totalAmtList, amountList)
	// 累计比例
	accumulateRatioList = ratioList
	restAmt = zhios_order_relate_utils.FloatFormat(restAmt, 6)

Loop:
	for node.ParentUser != nil { //查找上级用户
		node.ParentUser.Profit = 0

		//佣金补贴奖励
		subsidyFee, subsidyRatio, isOnlySubsidyFee, subsidyFeeList, subsidyRatioList := subsidyFeeDo(opt, totalAmt, integralTotalAmt, node.ParentUser, userList.NewLv, pvd, sysFee, integralSysFee)
		node.ParentUser.SubsidyFee = subsidyFee
		node.ParentUser.SubsidyFeeList = subsidyFeeList // 各币种补贴

		// 如果父级比当前级别低, 跳过
		// 同级奖, 如果父级别与当前级别一致,并且设置了对应比例
		count := len(grade[maxLv].PeerRate)
		if grade[maxLv].PeerRateList != nil {
			count = len(grade[maxLv].PeerRateList)
		}
		var isBreak bool
		zeroList := make(map[string]struct{})
		// 同级奖
		if node.ParentUser.LevelWeight == maxLevelWeight && count > peerNum {
			//同级奖励比例
			commission, commissionRatio, amountList, ratioList := CalReturnAmountAndRatio(maxLv, userList.OwnbuyReturnType, peerNum, "same_lv", totalAmt, integralTotalAmt, opt)
			//佣金                                                                                                           (lv,     isOnlySubsidy int, restAmt, profit, peerRate,      totalRatio,          restRatio,            subsidyFee, subsidyBili float64, opt *PlanOpt)
			node.ParentUser.Profit, restAmt, totalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, isBreak = sameMoney(node.Lv, isOnlySubsidyFee, restAmt, commission, peerRate, totalCommissionRatio, commissionRatio, node.ParentUser.SubsidyFee, subsidyRatio, opt)
			node.ParentUser.ProfitList, restAmtList, accumulateRatioList, peerRateList, node.ParentUser.SubsidyFeeList, zeroList = sameMoneyV2(node.Lv, isOnlySubsidyFee, totalAmtList, restAmtList, amountList, peerRateList, accumulateRatioList, ratioList, node.ParentUser.SubsidyFeeList, subsidyRatioList, opt)

			// 全部都没得分了
			if isBreak && len(zeroList) == len(opt.UserRate[maxLv].ReturnType) {
				break Loop
			}
			peerNum++
		} else if node.ParentUser.LevelWeight > maxLevelWeight {
			if _, ok := grade[node.Lv]; !ok {
				return zhios_order_relate_logx.Warn("level grade node.Lv is not set")
			}
			if _, ok := grade[node.ParentUser.Lv]; !ok {
				return zhios_order_relate_logx.Warn("level grade node.ParentUser.Lv is not set")
			}
			peerNum1 := 0 //不用扣同级
			commission, _, amountList, teamRatioList := CalReturnAmountAndRatio(node.ParentUser.Lv, userList.OwnbuyReturnType, peerNum1, "team", totalAmt, integralTotalAmt, opt)
			//佣金
			node.ParentUser.Profit = commission
			node.ParentUser.Profit, restAmt, totalCommissionRatio, node.ParentUser.SubsidyFee, isBreak = teamDiffMoney(node.ParentUser.Profit, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmt, restAmt, grade[node.ParentUser.Lv].TeamRate, totalCommissionRatio, peerRate, node.ParentUser.SubsidyFee, subsidyRatio)
			//积分
			node.ParentUser.ProfitList = amountList
			//                                                                                                                   profitList []*VirtualCoinCommission, payMode, isOnlySubsidy int, totalAmtList, restAmtList, teamRatioList, totalRatioList, peerRateList, subsidyFeeList, subsidyRatioList []*VirtualCoinCommission
			node.ParentUser.ProfitList, restAmtList, accumulateRatioList, node.ParentUser.SubsidyFeeList, zeroList = teamDiffMoneyV2(node.ParentUser.ProfitList, grade[node.Lv].PayMode, isOnlySubsidyFee, totalAmtList, restAmtList, teamRatioList, accumulateRatioList, peerRateList, subsidyFeeList, subsidyRatioList)

			// 没得分了 就结束
			if isBreak && len(zeroList) == len(opt.UserRate[maxLv].ReturnType) {
				break Loop
			}
			// 等级往上升则置0
			maxLevelWeight, maxLv, peerRate, peerRateList, peerNum = node.ParentUser.LevelWeight, node.ParentUser.Lv, 0, nil, 0
		}
		//如果是酒庄制度，要看这里处理 额外的补贴
		subsidyFee, subsidyRatio, isOnlySubsidyFee, subsidyFeeList, subsidyRatioList = subsidyFeeDo(opt, totalAmt, integralTotalAmt, node.ParentUser, userList.NewLv, pvd, sysFee, integralSysFee)
		node.ParentUser.SubsidyFee = subsidyFee
		node.ParentUser.SubsidyFeeList = subsidyFeeList // 各币种补贴
		node.Profit = zhios_order_relate_utils.StrToFloat64(fmt.Sprintf("%.4f", node.Profit))
		node = node.ParentUser
	}

	return nil
}
